/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "consts.H"
#include "G_Path.H"
#include "Aff.H"
#include "C_Menu.H"
#include <stdio.h>
#include "G_User.H"

G_Path G(30*60); // 30 minutes maxi
Aff A;

G_User * Moi;

int Menu_1(char ch)
{
    switch(ch)
	{
	case '1': return -3;
	case '2': A.DirectMSG("First");break;    // newbie
	case '4': return -2;                     // rights
	case '5': A.DirectMSG("Lexique"); break; // voc
	case '6': return -4;
	default: return 1;
	} 
    return 0;
}

int Menu_3(char ch)
{
  if ( ch >='1' && ch <='8' )
  {
    char temp[100];
    sprintf(temp,"ShortH%d",ch-'0');
    A.printf2(temp);
    A.Pause();
    return 0;
  }
  return 1;
}

const int nb_txt=11;

static const char * T[nb_txt] = {
    "Droit-R",  "Cland-R",   "Mouss-R",   "Barreur-R","Vigie-R",
    "Ilotier-R","Timonier-R","Armateur-R","Bourreau-R","Captain-R",
    "Gov-R" };

int Menu_2(char ch)
{
  if (ch >='0' && ch < '0'+nb_txt )
      { 
	  A.DirectMSG(T[ch-'0']); 
	  return 0; 
      }
  
  if ( ch =='T' ) 
      {
	  for (int i=0; i<nb_txt; i++) A.DirectMSG(T[i]);
	  return 0;
      }
 
  return 1;
}

const int nb_theme=6;

static const char * Hin[nb_theme]=
{
    "HelpRoom",  "HelpWholist", "HelpX",
    "HelpConfig","HelpJeux" , "HelpRoom2"
};

int Menu_4(char ch)
{
    if (ch >='0' && ch < '0'+nb_theme )
	{ 
	    A.DirectMSG(Hin[ch-'0']); 
	    return 0; 
	}
    return 1;
}

void PRINT(char ou,const char * temp)
{
  A.DirectMSG(temp);
}

int (* foncs[5])(char ) = { 0, Menu_1, Menu_2, Menu_3, Menu_4   };
C_Menu M(300,foncs,5,PRINT,"Tutoriel");

int main(int argc, char ** argv)
{
  if ( argc <  2 )
  {
    fprintf(stderr,"USAGE: %s ki\n",argv[0]);
    return 1;
  }

  Moi=new G_User(argv[1]);
  
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));

  if ( argc == 3 && ( !strcmp(argv[2],"keys") ) )
  M.push(3);
  else
  M.push(1);

  while (M.encours())
  {
    M.printline();
    M.GereKey();
  }
  return 0;
}

void terminate(void)
{
  printf("terminate appele ...\n");
  exit(0);
}

