/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "C_Menu.H"
#include "Aff.H"
// les 3: pour read
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
// for sprintf
#include <stdio.h>

#include "Debug.H"

extern Aff A;

C_Menu::C_Menu(int ldebut, int (** ZeFoncs)(char ), int ZeTaille, void (*f)(char, const char *),const char * menu)
  :Menu_Name(menu)
{
  lemenu=0;
  flags=0;
  no_print=1;
  debut = ldebut;
  fonc = ZeFoncs;
  nbdefoncs = ZeTaille;
  prompt = f;
}

void C_Menu::GereKey(void)
{
  int i;

  try
    {    
      c = A.GetCh();
      
      if ( encours() > nbdefoncs ) 
	{ 
	  Debug(1,"C_Menu::GereKey(): Menu impossible\n"); lemenu=0; return ; 
	}
      
      if ( ! ( fonc[encours()] )  ) 
	{ 
	  Debug(1,"C_Menu::GereKey() : Menu non gere\n"); DEFAULT(); return; 
	} 

      i=fonc[encours()](c);  
    }
  catch ( Cancel )
    {
#warning "Mettre dans le fichier M"
      printf("\nAction Cancelled\n");
      i = 0;
    }
  

  if (i==1) DEFAULT(); else if (i<0) push(-i);
  else if ( i==2 ) no_print = 1;
  /*
    i == 1 : on gere les touches \n, ' ', Q, q ... ( default du case )
    i == 2 : pas de print ( a virer ? )
    i <  0 : on passe sur le menu -i
    i == 0 : pas d'action particuliere
    */
}


C_Menu::~C_Menu(void)
{


}

void C_Menu::print(void)
{
  if (no_print==1) { no_print=0; return; }
}

void C_Menu::push(char ou)
{
  if (lemenu >= 5 ) Debug(1,"C_Menu::push() : pas + de 5 nvx !\n");
  else nummenu[lemenu++]=ou;
}

void C_Menu::DEFAULT(void)
{
  switch (c)
  {
    case 'q': case ' ': case '\n': 
      if (!lemenu) return;
      if (! --lemenu) A.ln();
    break;
    case 'Q': lemenu=0; A.ln();  break; 
    case '?': no_print=2; break;
    default: A.beep(); A.ln();
  }
}

unsigned char C_Menu::encours(void)
{ return lemenu?nummenu[lemenu-1]:0; }

int C_Menu::BIGprint(void)
{
  int aide=0;

  if (no_print==2) { aide=1; no_print=0; }

  return (lemenu && (!(flags & U_expert)  || aide));
}

void C_Menu::printline(void)
{
  char temp[100];
  sprintf(temp,"%s%02d",Menu_Name,encours());
  A.Blank();
  if ( BIGprint() ) 
    {
      A.printf2("debut",A.GetNum(debut+nummenu[lemenu-1]));
      prompt(encours(),temp); 
      A.printf2("fin");
    }
  else A.ln();
 
  for (int i=0; i<lemenu; i++ ) A.printnum(debut+nummenu[i]);
  //A.NewMore(); 
  A.Blank();
}


