/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "consts.H"
#include "C_User_C.H"
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include "C_Pipe.H"
#include "G_Path.H"
#include "Debug.H"

extern C_Pipe P;
extern G_Path G;
 
C_User_C::C_User_C(const char * zenom)
  :G_User(zenom),G_B_R_Pipe(G.GetCommFile(numdeuser)),
   DERNIER(0),DERNIERDERNIER(0),SG(0),CocoDate(0)
   
{
  int monpid;
 
  monpid=getpid();
  /* On previent le serveur de notre arrivee ... */
  P.numdeuser = numdeuser;
  P.EnvoieMsg((unsigned char)'h');          // Hello + num
  P.Envoie(&monpid,sizeof(monpid));         // On donne son pid pour le kill
  P.EnvoieG(Nick.data());                   // On donne not nom
  P.flush();
}


C_User_C::~C_User_C(void)
{
}


void C_User_C::Baille(void)
{
  pid_t p=getpid();
  P.EnvoieMsg('b');
  P.Envoie(&p,sizeof(p));
  P.flush();
}

void C_User_C::SendTag(void)
{
  P.EnvoieMsg('T');
  P.flush();
}

void C_User_C::SendMedor(void)
{
  P.EnvoieMsg('M');
  // Rajoute des trucs a envoyer si tu te sens :o))
  // Apres un EnvoieMsg, c'est des Envoie k'il faut faire
  P.flush(); // Pas oublier
}


void C_User_C::SendX(const LISTE & a,unsigned char koa, const char * Message, unsigned short right)
{
  if ( ! Message ) return;          // Do not send empty messages
 
  P.EnvoieMsg('R');                 // Room
  P.Envoie((unsigned char)'p');     // Add a post
  P.Envoie((unsigned short)0);      // room 0 = X-log room
  P.EnvoieG(Message);               // Do not delete [] Message
  P.Envoie(right);
  
  P.Envoie(koa);                    // type of X
  P.Envoie(a);                      // to it is sent
  P.flush(); 
}

void C_User_C::Liste_Roumes(void)
{
  P.EnvoieMsg('R');             // room
  P.Envoie((unsigned char)'k'); // list of rooms
  P.flush();
}

void C_User_C::Reboot(void)
{
  P.EnvoieMsg('r'); 
  P.flush();
}

void C_User_C::LoadMsg(void)
{
  P.EnvoieMsg('n'); 
  P.flush();
}

void C_User_C::Ack(unsigned short ki, unsigned char type)
{
  P.EnvoieMsg((unsigned char)'a');
  P.Envoie(ki);
  P.Envoie(type);
  P.flush();
}
 
void C_User_C::Mail(const LISTE & a, const char * post, int reply )
{
  P.EnvoieMsg('R');                 // room action
  P.Envoie((unsigned char)(reply ? 'P':'p'));     // post 
  P.Envoie((unsigned short)1);      // room 1 = room mail
  P.EnvoieG(post);
  P.Envoie((unsigned short)0);      // rights
  P.Envoie(a);  
  P.flush();
  D->Inc(N_Post,1);
}

void C_User_C::Poste(unsigned short NumRoom, 
		     const char * subject, const char * alias,
		     const char * post,
                     int reply, unsigned short right )
{
  P.EnvoieMsg('R');               // room action
  P.Envoie((unsigned char)(reply ? 'P':'p'));  // post a message
  P.Envoie(NumRoom);
  P.EnvoieG(post);
  P.Envoie(right);
  P.EnvoieG(subject);
  P.EnvoieG(alias); 
  P.flush();
  D->Inc(N_Post,1);
}

void C_User_C::ZapRoom(LISTE & a)
{
  P.EnvoieMsg('R');
  P.Envoie((unsigned char)'z');
  P.Envoie(a);
  P.flush();
}

void C_User_C::DeletePost(unsigned short NumRoom, unsigned short posi)
{
  P.EnvoieMsg('R');                   // room
  P.Envoie((unsigned char)'D');      // Delete a post
  P.Envoie(NumRoom);
  P.Envoie(posi);
  P.flush();
}

void C_User_C::GetNextPost(unsigned short NumRoom)
{
  P.EnvoieMsg('R');              // room
  P.Envoie((unsigned char)' '); // get next post
  P.Envoie(NumRoom);
  P.flush();
}

void C_User_C::SetPosRoom(unsigned short NumRoom, unsigned short nvellepos)
{
  P.EnvoieMsg('R');             // room
  P.Envoie((unsigned char)'d'); // change the pos in the room
  P.Envoie(NumRoom);
  P.Envoie(nvellepos);
  P.flush();
}

void C_User_C::CopierPost(unsigned short NumRoom,unsigned short NumPost, 
			  unsigned short NvelleRoom)
{
  P.EnvoieMsg('R');             // room
  P.Envoie((unsigned char)'C'); // Copy a post
  P.Envoie(NumRoom);            // From numroom
  P.Envoie(NumPost);            // This Post
  P.Envoie(NvelleRoom);         // To this room
  P.flush();
}

void C_User_C::Jump_To_Room(unsigned short room, unsigned char dir)
{
  P.EnvoieMsg('R');             // room
  P.Envoie((unsigned char)'R'); // go to a new room
  P.Envoie(room);               // room to start
  P.Envoie(dir);                // action to do ( +, -, j, ) , (, ... )
  P.flush();
}

void C_User_C::Get_Tag(Un_Tag & a)
{ 
  Lit(a.type);
  switch ( a.type )
    {
    case 'R': case 'S':
      Lit(a.ki);
      Lit(&(a.Date),sizeof(a.Date));
      break;
    case 'L': case 'E':
      Lit(a.ki);
    }
}

void C_User_C::Get_Medor(Un_Medor & a)
{
  // rien pour le moment
  // receptionne un message envoye par le serveur
}

void C_User_C::Get_RListe( RListe &  a)
{
  unsigned char type;
  unsigned short posi,room;		   
  
  Lit(room);
  while ( room != 65535 )
    {
      Lit(type);
      Lit(posi);
      switch ( type )
	{
	case 'Z': a.Z->Ajoute(room); break;
	case 'K': a.K->Ajoute(room); break;
	case 'F': a.L->Ajoute(room); break;
	case 'N': 
	  if (posi) a.E->Ajoute(room);
	  else     a.N->Ajoute(room);
	  break;
	default: Debug(3,"C_User_C::Get_RListe: BUG(%c)!\n",type);
	}
      Lit(room);
    }
}

void C_User_C::Get_X(Un_X & a)
{
  Lit(a.ki);    // who sent the X
  Lit(a.type);  // what sort of X it is
  Lit(a.right); // what are the corresponding rights
  
  if ( a.ki != numdeuser ) 
    {
      D->Inc(N_Xr,1);
    }
  switch ( a.type )
    {
    case '*':
      Lit(a.num); 
    break;
    default:
      Lit(a.buf);
    }   
  
  DERNIERDERNIER = DERNIER;
  DERNIER=a.ki;
}

void C_User_C::Get_Ack(int r, Un_Ack &  a)
{
  Lit(a.ki);
  Lit(a.type);
  a.received = r;
}

void C_User_C::Get_Log(int r,  Un_log & a)
{
  Lit(a.ki);
  a.in = r;
}

void C_User_C::Get_Post(Un_Post & a)
{
  try 
    {
      Get_Room(a.room);
      Lit(a.TYPE_ROOM);
      Lit(&(a.date),sizeof(a.date));
      Lit(a.post); 
      Lit(a.right);
      Lit(a.move_u);
      if ( a.move_u ) Lit(a.move_r);
      Lit(a.reply_r);
      if ( a.reply_r )
	{
	  Lit(a.reply_n);
	  Lit(a.reply_s);
	  Lit(a.reply_u);
	}
      switch (a.TYPE_ROOM)
	{
	case 'L': case 'M':
	  Lit(a.nb);
	  a.Ki = new unsigned short[a.nb];
	  a.Koa= new unsigned char[a.nb];
	  if ( a.nb )
	    {
	      Lit(a.Ki,a.nb*sizeof(short));
	      Lit(a.Koa,a.nb*sizeof(char));
	    }
	  a.ki = a.Ki[0];
	  if ( ! a.room.numroom ) Lit(a.type); 
	  break;
	case 'N':
	  Lit(a.ki);
	  Lit(a.alias);
	  Lit(a.sujet);
	  break;
	default:
	  Debug(3,"BUG !! :Post type not supported !!\n");
	}
    }
  catch ( ErreurLecture )
    {
      Debug(3,"Oups ... I'm going to try a BUG recovery, pray ...\n");
      a.ki = 0;
      a.sujet = 0;
      a.nb = 0;
      a.alias = 0;
      a.post = (char *)strdup("Dummy message ....\n");
      Debug(3,"Sometimes, doing <B> <10> solves the problem ...\n");
    }
}

void C_User_C::Get_Room(Un_Roume & a)
{
  Lit(a.numroom);
  Lit(a.maxpos);
  Lit(a.pos);
}

void C_User_C::LoadConfig(void)
{
  P.EnvoieMsg('c');
  P.flush();
}


