/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: G. Vandenbrouck <vdb@gnu.org>
   Please, send him/them a mail ( possibly with diff and/or correction )

   If you find any BUG, or if you do any improvement */

#ifndef __EDITOR__
#define __EDITOR__

#include "String.H"

// Editor options constants
const unsigned short E_Color = 1<<0; // Color is considered
const unsigned short E_Length= 1<<1; // Length is visible length not "real" length
const unsigned short E_Ascii = 1<<2; // Ascii ART mode (double the antislash cars)
const unsigned short E_Insert= 1<<3; // Insertion mode

typedef struct 
{
  unsigned short min, // min number of lines
    max,              // max number of lines
    length,           // max length of a line
    options;          // current options
  const String & begin;       // beginning of line
  char color;         // Default color of the string
} EditorContext;


class Editor
{
public:
  Editor();
  GetString(const EditorContext & , String & );
  ~Editor();
private:
  

};


#endif
