/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __G_B_S_PIPE__
#define __G_B_S_PIPE__

#include "SEND.H"

/*
  General Bufferized Pipe to SEND data ......
  Deals with:
  - infinite size
  - Sending data by pacquets ..

*/


class SendPipeProbs
{
};

class G_B_S_Pipe: public virtual SEND
{
private:
  int f;         // file descripter of the pipe 
  int bufsize;   // size of the buffer
  int pos;       // position in buffer for sending
  char * buffer; // buffer
public:
  G_B_S_Pipe(char *);
  ~G_B_S_Pipe();
  
  void Envoie(const void * koa, unsigned int taille);
  void flush(void);
  
  void Envoie(unsigned short i) { SEND::Envoie(i); }
  void Envoie(unsigned char i) { SEND::Envoie(i); }
  void Envoie(const String & i) { SEND::Envoie(i); }
  void EnvoieG(const char *  i ) { SEND::EnvoieG(i); }
  void EnvoieD(char * & i ) { SEND::EnvoieD(i); }
  void EnvoieMsg(char i) { SEND::EnvoieMsg(i); }  
  void Envoie(const LISTE & a) { SEND::Envoie(a); }
private:
  void Packet(void *,int );
};

#endif
