/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "G_B_S_Pipe.H"
#include "Debug.H"
// pour printf
#include <stdio.h>
// Ce ki suit, pour open()
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
// pour write
#include <unistd.h>
//pour realloc
#include <stdlib.h>

#include "MAX.H"

const int MAX_BUF = 2000;
const int MAX_TRY = 3;

G_B_S_Pipe::G_B_S_Pipe(char * name)
  :SEND(),bufsize(MAX_BUF),pos(3),buffer(0)
{
  f = open(name,O_WRONLY | O_NDELAY);

  if ( f == -1  )
    {
      Debug_Error(3,"G_B_S_Pipe::G_B_S_Pipe(): Can not connect to %s\n",name);
      delete [] name;

      throw SendPipeProbs();
    }
  delete [] name;

  buffer = new char [MAX_BUF];
}


void G_B_S_Pipe::Envoie(const void * koa, unsigned int taille)
{ 
  unsigned int i;
  char * pipo = (char *)koa;
  for ( i=0; i< taille; i++) 
    {
      buffer[pos++] = * pipo ++;
      if ( pos == bufsize ) 
	{
	  // Debug(1,"WARNING: reaching maximum size !\n");
	  //printf("ANCIENNE TAILLE: %d\n",bufsize);
	  bufsize += taille - i + 10;
	  //printf("NOUVELLE TAILLE: %d\n",bufsize);
	  buffer = (char *)realloc(buffer,bufsize);
	  //printf("OKI\n");
	}
    }
}

void G_B_S_Pipe::Packet(void *a,int size)
{
  if ( ! size ) return;

  int nb_try = 0;
  
  int n = write(f,a,size);
  
  while ( n == -1 && nb_try < MAX_TRY )
    {
      nb_try ++;
      printf(".\n");
      sleep(1);
      n = write(f,a,size);           
    }

  if ( n == -1 ) 
  {
    Debug_Error(3,"G_B_S_Pipe::flush(): can not send data\n");
    throw SendPipeProbs();
  }
  if ( n != size)
    {
      Debug_Error(3,"G_B_S_Pipe::flush(): %d/%d data sent\n",n,pos);
      throw SendPipeProbs();
    }
}


void G_B_S_Pipe::flush(void)
{ 
  unsigned short nb = (pos-3) / SIZE_PACKET;  
  unsigned short i;
  unsigned short lapos;
  
  for (i=0; i< nb; i++)
    {  
      printf("OUPS GRANDS PAQUETS !\n");
      lapos = i*SIZE_PACKET + 3 -1;
      buffer[lapos] = '~';
      Packet(buffer + lapos,SIZE_PACKET+1);
    }
  
  unsigned short taille = (pos-3) % SIZE_PACKET;
  lapos = i*SIZE_PACKET +3 -3;
  buffer[lapos] = '#';
  unsigned short * poil = (unsigned short * ) ( buffer + lapos + 1 );
  * poil = taille;

  Packet(buffer+lapos,taille+3);
 
  pos = 3;
}

G_B_S_Pipe::~G_B_S_Pipe(void)
{  
  close(f); 
  if (buffer) delete [] buffer;
}


