/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __G_HASH__
#define __G_HASH__

/*
  Generik hashtable class.
  used to complete a char * and to find one esailly 
*/

#include "wholist.H"

class G_Hash
{
protected:
  LAWHOLIST m;
public :
  G_Hash(LAWHOLIST);
  
  unsigned short rechercher(const char *nom) const;    // look for a string
  char * complete(const char *nom, unsigned short it); // complete a string
  char * I_Str(unsigned short i) const;  // Get an indexed string
  static int match(const char * , const char * );
  // where are stored the strings
  virtual char * Str(unsigned short i) const = 0;            
  virtual unsigned short & table(unsigned short i) const = 0;// table
  virtual unsigned short & index(unsigned char A) const = 0; // index table
  virtual unsigned short & nb(void) const = 0; // number of entries
  virtual int ok(unsigned short) = 0; // can we use this entry ?
  /*
    ok use:
    for a user, complete if and only if it is connected
    for a room, check that the room is not hidden for this user
    for a list: check the user is invited
    ...
   */
};


#endif
