/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __G_USERS__
#define __G_USERS__

#include "LISTE.H"
#include "uread.H"
#include "Dat.H"

/*
  The G_User class is the generik class for a user.
  It first reads and store all user data in the D field.
  You should read Dat.H yo understand how to retrieve this data.
  It throws BadUser() if the data is not valid 
*/

// String fields
enum ChampsLoades { 
  C_nom,       C_adresse, C_zip,   C_ville,
  C_pays,      C_doing,   C_mail,  C_url,
  C_tel,       C_host,    C_last,  C_from,
  C_disraison, C_alias,   C_extra, C_TwitR,
  C_TwitA,     C_color,   C_map,   C_CV, 
  C_Welcome
};
// list fields
enum ChampsListes
{
   L_friends, L_ennemys, L_quick, L_ignore
};
// numerik lists
enum ChampNumerik {
  N_langue,   N_comprises, N_flags,    N_first,
  N_birthday, N_tpspasse,  N_numdeuser,N_logins,
  N_cflag,    N_TagSc,     N_KHsc,     N_lastlog, 
  N_CWhol,    N_logout,    N_TwitT,    N_more, 
  N_Xe,       N_Xr,        N_Post,     N_idle,
  N_ICQ,      N_Parain,    N_Chery,    N_key,
  N_lastkey,  N_keylog,    N_MedorSc
};

class G_User  // Generik class for a user
{
public:
  Dat * D;      // All the data, see Dat.H to understand
  String Nick;  // nickname
  unsigned short numdeuser; // usernumber
public:
  G_User(const char * );
  ~G_User(void);
  void Lit_Sauve(enum TypeLecture); // Read or save
  int NotValid(void);  // is the user valid ?
  int IsHelp(void);    
  int IsVerif(void);
  int IsRooms(void);
  int IsUsers(void);
  int PlayCoco(void);
  int IsAdmin(void);
};

class BadUser {} ; // throwed if the userinfo is corrupted

#endif

