/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

//  Charge infos d'1 user dans une classe
//  C tout
#include "G_Path.H"
#include "consts.H"
#include "G_User.H"
#include "uread.H"
#include "MAX.H"
#include "USER.H"

extern G_Path G;

static const char * infos = "infos";
//const char * pswd  = "pswd";  // Pas static, paske besoin dans client

G_User::G_User(const char * lenom)
  :Nick(lenom)
{
  D = new Dat(U_cle,tailles,MAX_CH, MAX_L);
  try
    {
      Lit_Sauve( k_Read );
    }
  catch ( FileProbs )
    {
      numdeuser = 0;
    }
  if ( numdeuser == 0 ) throw BadUser();
}

G_User::~G_User(void)
{
  delete D;
}

void G_User::Lit_Sauve(TypeLecture LeType)
{
  if ( LeType == k_Write ) D->SetNum(N_numdeuser,numdeuser);

  FileInfo FF(G.GetUserFile(Nick,infos),LeType,D);
  
  FF.Proceed();

  if ( LeType == k_Read ) numdeuser= D->Num(N_numdeuser);
}

int G_User::NotValid(void)
{
  int nvalid = 0;
  if ( ! ( D->Set(N_flags,D_untwit)) ) nvalid = 1;
  if (  D->Num(N_TwitT) ) nvalid |= 2;
  if ( D->Num(N_key) && (D->Num(N_keylog) >3) ) nvalid |= 4;
  return nvalid;
}


int G_User::IsHelp(void)
{
  return D->Set(N_flags,D_help);
}

int G_User::IsVerif(void)
{
  return D->Set(N_flags,D_verif);
}

int G_User::IsRooms(void)
{
  return D->Set(N_flags,D_rooms);
}

int G_User::IsUsers(void)
{
  return D->Set(N_flags,D_users);
}

int G_User::PlayCoco(void)
{
  return D->Set(N_cflag,U_PTag);
}

int G_User::IsAdmin(void)
{
  return D->Set(N_cflag,D_admin);
}
