/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "G_wholist.H"
#include "consts.H"
#include <time.h>
#include <string.h>
#include <stdio.h>


G_wholist::G_wholist(void)
{
}

G_wholist::~G_wholist(void)
{
}


int G_wholist::exist(unsigned short num)
{
  return( (num < MAX_USERS) && (mem->UserName[num][0]!=0) );
}

int G_wholist::connected(unsigned short num)
{
  return ( (int)User(num) );
}

unsigned short G_wholist::NB(void)
{ 
  return mem->nbpers;
}

char NomKiChie[100];

char * G_wholist::name(unsigned short num)
{
  if ( num >= MAX_USERS ) return "BIG BUG";
  char * tmp = mem->UserName[num];
  if ( tmp[0] ) return tmp;
  sprintf(NomKiChie,"Deleted(%d)",num);
  return NomKiChie;
}

LISTE * G_wholist::RoomsRA(unsigned short ki)
{
  LISTE * temp = new LISTE(MAX_ROOM);
  for ( int i=0; i<MAX_ROOM; i++ )
    if ( IsRA(ki,i) ) temp->Ajoute(i);
  return temp;
}

int G_wholist::IsRA(unsigned short ki, unsigned short ou)
{
  if ( ki >= MAX_USERS && ou >= MAX_ROOM ) return 0;
  ROOMINFO *  poil = Room(ou);
  LISTE a(MAX_RA,poil->RA,&(poil->NB_Ra));
  return a.cherche(ki);
}

int G_wholist::IsInvited(unsigned short user, unsigned short room)
  // Is the user invited in ze roume
{
  ROOMINFO * poil = Room(room);
  LISTE a(MAX_INVITED,poil->INVITED,&(poil->NB_Invited));
  return a.cherche(user);
}

char * G_wholist::RoomName(unsigned short num)
{
  if ( num >= MAX_ROOM ) return "BIG BUG";
  return mem->RoomName[num];
}

unsigned short G_wholist::HaveTAG(void)
{
  for (int i=0;i<NB();i++)
    {
      USRINFO * poil = mem->Infos + mem->place[i];
      if ( poil->u_wholist & W_Tag) return  mem->ki[i];
    }
  return 0;
}

int G_wholist::IsAVote(void)
{
   for (int i=0;i<NB();i++)
    {
      USRINFO * poil = mem->Infos + mem->place[i];
      if ( poil->u_wholist & W_Vote) return  mem->ki[i];
    }
  return 0; 
}

USRINFO * G_wholist::User(unsigned short ki)
{
  if ( ki >= MAX_USERS ) return 0;
  for ( unsigned short i=0; i< NB(); i++ )
    if ( mem->ki[i] == ki ) return mem->Infos + mem->place[i];
  return 0;
}

ROOMINFO * G_wholist::Room(unsigned short ki)
{
  if ( ki >= MAX_ROOM ) return 0;
  return mem->Rooms + ki;
}

int G_wholist::IsRobot(unsigned short ki)
{
  USRINFO * temp = User(ki);
  return (ki && ( temp->u_wholist & W_Robot ));
}

char * G_wholist::St(int i)
{
  return mem->St[i];
}
