/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

//#include <stdio.h>
//#include <string.h>
#include "Passwd.H"
#include "G_Path.H"
#include "Debug.H"
#include "MAX.H"

const char * pswd = "pswd";

extern G_Path G;

int test_passwd(const char * App,const char * user, const char * passwd)
{
  FILE * f;
  char PASSWD[MAX_PASSWD+1];
  char * temp=G.GetUserFile(user,pswd);  
  f=fopen(temp,"r");
  delete [] temp;

  if (! f )
    {
      Debug(3,"NO PASSWD !\n");
      return 0;
    }
  fgets(PASSWD,MAX_PASSWD,f);
  PASSWD[strlen(PASSWD)-1]=0;
  fclose(f);

  int ok = ! strcmp(PASSWD,passwd);

  return ok;
}

int set_passwd(const char * App,const char * user, const char * passwd)
{
  FILE * f;
  char * temp=G.GetUserFile(user,pswd);  
  f=fopen(temp,"w");
  delete [] temp;
  if ( ! f )
    {
      Debug(3,"Could not create passwd file ! \n");
      return 0;
    }
  fprintf(f,"%s\n",passwd);
  fclose(f);
  return 1;
}

