/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "SEND.H"

void SEND::Envoie(unsigned short a)
{ Envoie(&a,sizeof(short)); }

void SEND::Envoie(unsigned char a)
{ Envoie(&a,sizeof(char)); }

void SEND::EnvoieG(const char * truc)
{
  unsigned short taille;

  if (truc)
  {
    taille=strlen(truc);
    Envoie(taille);
    Envoie(truc,taille); 
    //    printf("Envoi d'une chaine (%d): %s\n",taille,truc);
  } else
  {
    taille=0;
    Envoie(taille);
  }
}

void SEND::Envoie(unsigned char e,Dat * D)
{
  Envoie(e);                    // Send type of Data
  Envoie((unsigned char)'!');   // Data modification notification
  unsigned short nb_modif,i;
  nb_modif = 0;
  for (i=0; i<D->NC(); i++)
    {
      if ( D->Modif_Chp[i] ) nb_modif ++;
    }
  Envoie(nb_modif);
  for (i=0; i<D->NC(); i++)
    {
      if ( D->Modif_Chp[i] )
	{
	  Envoie(i);
	  Envoie(D->St(i));
	  D->Modif_Chp[i]=0;
	}
    }

  nb_modif = 0;
  for (i=0; i<D->NC(); i++)
    {
      if ( D->Modif_Chp[i] ) nb_modif ++;
    }
  Envoie(nb_modif);
  for (i=0; i<D->NN(); i++)
    {
      if ( D->Modif_Num[i] )
	{
	  Envoie(i);
	  unsigned long n=D->Num(i);
	  Envoie(&n, sizeof(unsigned long));
	  D->Modif_Num[i]=0;
	}
    }

  nb_modif = 0;
  for (i=0; i<D->NL(); i++)
    {
      if ( D->Modif_List[i] ) nb_modif ++;
    }
  Envoie(nb_modif);
  for (i=0; i<D->NL(); i++)
    {
      if ( D->Modif_List[i] )
	{
	  Envoie(i);
	  Envoie(* D->L(i));
	  D->Modif_List[i]=0;
	}
    }
}

void SEND::Envoie(const String & a)
{
  unsigned short taille;
  const char * truc = a.data();

  taille=strlen(truc);
  Envoie(taille);
  // printf("Envoie d'une chaine (%d) : %s\n",taille,truc);
  if (taille)   Envoie(truc,taille);
}

void SEND::Envoie(const LISTE & a)
{
  unsigned short b = a.size();
  Envoie(b);
  if (b) Envoie(&(a.DATA[0]),b*sizeof(short));
}

void SEND::EnvoieD(char * & truc)
{
  EnvoieG(truc);
  if ( truc ) 
    {
      delete [] truc;
      truc = 0;
    }
}

void SEND::EnvoieMsg(unsigned char c)
{ 
  Envoie(c);
  Envoie(numdeuser); 
}




