/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __CONSTS__
#define __CONSTS__

// User rights
const unsigned short D_untwit=1<< 0;  // un utilisateur a besoin de ca pour pouvoir
                       // ecrire a d autres. Si pas, passager clandestin 
const unsigned short D_help  =1<< 1;  // Help other users
const unsigned short D_verif =1<< 2;  // Verify new accounts
const unsigned short D_rooms =1<< 3;  // Administrates rooms upper than 10
const unsigned short D_users =1<< 4;  // This user can administrate all other users
const unsigned short D_1_room=1<< 5;  // The user administrates one room or more
const unsigned short D_old   =1<< 6;  // Old user
const unsigned short D_kick  =1<<10;  // This user can kick other users out of the bbs
const unsigned short D_admin =1<<11;  // Big admin (shutdown of bbs...)

// Definition des langues existantes, 16 possibilites
const unsigned short L_fr = 1 << 0;  // francais
const unsigned short L_uk = 1 << 1;  // anglais
const unsigned short L_sp = 1 << 2;  // espagnol
const unsigned short L_no = 1 << 3;  // norvegien
const unsigned short L_it = 1 << 4;  // italien
const unsigned short L_ta = 1 << 5;  // tafiolle

// Quelques defs de flags a la con
// Les flags a la con ne sont pas des flags donnant un grade
 /* Couleurs */
const unsigned long U_ansi    = 1<< 0;
const unsigned long U_bold    = 1<< 1;
const unsigned long U_flash   = 1<< 2;
 /* divers */
const unsigned long U_Dis     = 1<< 3; // disable au login
const unsigned long U_bip     = 1<< 4; // bips pour les Xmessages
const unsigned long U_PTag    = 1<< 5; // Jouer au Tag
const unsigned long U_PKH     = 1<< 6; // Jouer avec KHagland
const unsigned long U_LgSay   = 1<< 7; // Prevenir si on X kkun de yapasbon langue
 /* cacher infos */  
const unsigned long U_C_name  = 1<< 8; // Cacher le nom
const unsigned long U_C_num   = 1<< 9; // Cacher le num
const unsigned long U_C_log   = 1<<10; // Cacher nb logins
const unsigned long U_C_mail  = 1<<11; // Cacher le mail
const unsigned long U_C_pays  = 1<<12; // Cacher le pays
const unsigned long U_C_time  = 1<<13; // Cacher le temps passe
const unsigned long U_C_first = 1<<14; // Cacher la date de 1ere connection
 /*  autres */ 
const unsigned long U_expert  = 1<<15; // Expert user
const unsigned long U_LShow   = 1<<16; // Montrer les amis au login
const unsigned long U_LLShow  = 1<<17; // Montrer login / logout des amis
const unsigned long U_Conf_Mv = 1<<18; // Conf mv cp
const unsigned long U_Conf_Yel= 1<<19; // Conf Yell
const unsigned long U_Barre   = 1<<20; // Barre aide ?
const unsigned long U_Conf_Sav= 1<<21; // Faut il sauver les modifs ?
const unsigned long U_BipCopain=1<<22; // Beep si copain se loge
const unsigned long U_Verified= 1<<23; // Un Sysop a verifie le compte
/* confirmations diverses et variees */
const unsigned long U_Conf_Mod= 1<<24; // confirmer une modif de champ
const unsigned long U_Conf_Pro= 1<<25; // confirmer voir profile
const unsigned long U_Conf_Log= 1<<26; // Non confirmation du logout
const unsigned long U_Conf_Ed = 1<<27; // Non confirmation edition fichiers
const unsigned long U_Conf_Del= 1<<28; // Non confirmation effacement post
const unsigned long U_Conf_Stop=1<<29; // Non confirmation oublier posts
const unsigned long U_Conf_Zap= 1<<30; // Non confirmation zap
const unsigned long U_Conf_Res= 1<<31; // Non confirmation reset


// Flags pour la custom Wholist
const unsigned short CW_Short    = 1 << 0; // Dit si la custom est short ou pas
const unsigned short CW_Depart   = 1 << 1; // Vrai au depart ou pas ?
const unsigned short CW_Frlist   = 1 << 2; // et / ou
const unsigned short CW_Ennemy   = 1 << 3;
const unsigned short CW_French   = 1 << 4;
const unsigned short CW_English  = 1 << 5;
const unsigned short CW_Spain    = 1 << 6;

// Temporary flags, exist when user is logged
// Appear in wholist, 
//const unsigned short W_Here   = 1<< 0; // Loge
const unsigned short W_Help   = 1<< 1; // Avaliable to help others ....
const unsigned short W_Disabl = 1<< 2; // User is disable
const unsigned short W_poste  = 1<< 3; // User is posting
const unsigned short W_Chat   = 1<< 4; // User is in the chat (not done yet)
const unsigned short W_X      = 1<< 5; // User is Xing
const unsigned short W_buisy  = 1<< 6; // User is buisy (not done yet)
const unsigned short W_Hidden = 1<< 7; // User is hidden in wholist
const unsigned short W_Tag    = 1<< 8; // User has Coco on its shoulder
const unsigned short W_Robot  = 1<< 9; // User must be considered as a robot
const unsigned short W_Vote   = 1<<10; // User is voting
const unsigned short W_Client = 1<<11; // User use the client

// Flags pour une room
// euh, a modifer ...
const unsigned short R_subject= 1<< 0; // Cette room a des sujects
const unsigned short R_anonym = 1<< 1; // On peut poster anonymous
const unsigned short R_invite = 1<< 2; // il faut etre invite pour pouvoir poster
const unsigned short R_invisi = 1<< 3; // il faut etre invite pour voir room
const unsigned short R_1_only = 1<< 4; // Only one person can post in a time
// 1 << 5: nothing
const unsigned short R_male   = 1<< 6; // C une room mec   ( ? ) 
const unsigned short R_female = 1<< 7; // C une room nana  ( ? ) 
const unsigned short R_scram  = 1<< 8; // post en scramble ( ? )
const unsigned short R_inv    = 1<< 9; // post en inverse  ( ? )
// ............................
 




#endif




