/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: S. BONNEFOY cerbere@resus.univ-mrs.fr
   Please, send him/them a mail ( possibly with diff and/or correction )

   If you find any BUG, or if you do any improvement */

#ifdef DEVELOP
#include "stdio.h"
struct {
  int GetCh()
    {
      return getchar();
    }
  void Direct(const char *in)
    {
      printf(in);
    }
  void Direct(const char in)
    {
      putchar(in);
    }
  char *ColourChar(char key)
    {
      char * s;
      
      switch(key)
	{
	case 'd': s="[30m"; break; /* dark textcolor		*/
	case 'r': s="[31m"; break; /* red textcolor		*/
	case 'g': s="[32m"; break; /* green textcolor		*/
	case 'y': s="[33m"; break; /* yellow textcolor		*/
	case 'b': s="[34m"; break; /* blue textcolor		*/
	case 'p': s="[35m"; break; /* purple textcolor		*/
	case 'c': s="[36m"; break; /* cyan textcolor		*/
	case 'w': s="[37m"; break; /* white textcolor		*/
	case 'D': s="[40m"; break; /* dark backgroundcolor	*/
	case 'R': s="[41m"; break; /* red backgroundcolor	        */
	case 'G': s="[42m"; break; /* green backgroundcolor	*/
	case 'Y': s="[43m"; break; /* yellow backgroundcolor	*/
	case 'B': s="[44m"; break; /* blue backgroundcolor	*/
	case 'P': s="[45m"; break; /* purple backgroundcolor	*/
	case 'C': s="[46m"; break; /* cyan backgroundcolor	*/
	case 'W': s="[47m"; break; /* white backgroundcolor	*/
	case 'a': s="[0m";  break; /* 'reset'-attribute		*/
	case 'u': s="[4m";  break; /* 'underlined'-attribute	*/
	case 'f': s="[1m";  break; /* 'bold'-attribute      */
	case 'e': s="[5m";  break; /* 'flashing'-attribute  */
	case 'i': s="[7m";  break; /* 'hidden'-attribute	*/
	case '\\' : s="\\"; break;
	default: sprintf(s, "%c", key);   
	}
      return(s);
    }
} A;
#endif
#ifndef DEVELOP
#include "Aff.H"
#endif
#include "edit_internal.H"
#include "edit.H"

/*****************************************************************************/
/* Commands : Traitement de tout ce qui est tape au clavier                  */
/*****************************************************************************/

void Commands::input()
{
  char tampon;
  int i;
  tampon=A.GetCh();
  switch(tampon)
  {
  case /*CtrlKey*/'\t' :
    for (i=0; i<8; i++)
      insert(' ');
    break;
  case '\\': // color key
/*    if (!((getline()+1)>=ct->max && getcol()>(ct->lgligne-3)))
      {*/
    if (ct->options)
      {
	tampon=A.GetCh();
	color(tampon);
      }
    else 
      {
	Display::insert(tampon);
	Buffer::insert(tampon);
      }
      /*}*/
    break;
  case 27 : //ESC
    tampon=A.GetCh();
    ctrlkey(tampon);
    break;
  case 1 : // ^A Mode asciiArt
    ct->options=!ct->options;
    break;
  case 3 : // ^C Abort
    *fin=1;
    cancel();
    break;
  case 4 : // ^D Fin d'edit
    *fin=1;
    break;
  case 5 : // ^E Mode fin d'edit = CtrlD
    CtrlD=!CtrlD;
    break;
  case 8 : case 127:// ^H : BS
    bkspace();
    break;
    //  case '\n': //RC
  case 10 :
    if ((Buffer::emptyline()) && (CtrlD==0)) 
      {
	*fin=1;
	finedit();
      }
    else 
      if ((getline()+1)>=ct->max)
	{
	  *fin=1;
	}
      else
	{
	  retch();
	}
    emptyline=1;
    break;
  default :
    insert(tampon);
  }
}
  
void Commands::insert(char tampon)
{
  if (((getline()+1)>=ct->max && getcol()>(ct->lgligne-3)))
    ;
  else
    {
      emptyline=0;
      if (mode == mdinsert)
	{
	  Display::insert(tampon);
	}
      else 
	{
	  if ((getcol()) > ct->lgligne)
	    {
	      retch();
	    }
	  Display::write(tampon);
	  Buffer::write(tampon);
	}
    }
}

void Commands::color(char c)
{
  switch (c)
    {
    case '\\':
/*      Display::insert(c);
      Buffer::insert(c);
      break;*/
    case 'd':
    case 'r':
    case 'g':
    case 'y':
    case 'p':
    case 'b':
    case 'c':
    case 'w':
    case 'D':
    case 'R':
    case 'G':
    case 'Y':
    case 'B':
    case 'P':
    case 'M':
    case 'C':
    case 'W':
    case 'i':
    case 'f':
    case 'u':
    case 'e':
    case 'a':
      Display::color(c);
      Buffer::color(c);
      break;
    }
}
void Commands::finedit()
{
  Buffer::finedit();
}

void Commands::cancel()
{
  Buffer::cancel();
}
void Commands::bkspace()
{
  Display::bkspace();
}
void Commands::exec(char key)
{
  key=0;
}
void Commands::ctrlkey(char key)
{
  switch(key)
    {
    case '[' :
       key=A.GetCh();
      switch (key)
	{
	case 'A' : //up
	  break;
	case 'B' : //down
	  break;
	case 'C' : //right
	  right();
	  break;
	case 'D' : //left
	  left();
	  break;
	case 'P' :
	  bkspace();
	case '3' : //suppr
	  key=A.GetCh();
	  if (key=='~') bkspace();
	  break;
	case '2' :
	  key=A.GetCh();
	  if (key=='~') mode=(mode==mdinsert?mdoverwrite:mdinsert);
	  break;
	}
      break;
    }
}
void Commands::retch()
{
  if (newline()>ct->max)
    {
      *fin=1;
      return;
    }
  //printf("\n\r%c",ct->debut);
  Display::retch();
  Buffer::retch();
}

/*****************************************************************************/
/* Display : Traitement de tout ce qui est affiche a l'ecran                 */
/*****************************************************************************/

Display::~Display()
{
}

void Display::color(char c)
{
  if (ct->options && isaffichable(c))
     A.Direct(A.ColourChar(c));
  //  refresh();
}

void Display::refresh()
{
int n; 
char tampon[10]; 
 A.Direct("\033[2D\033[K");
 n = puts(geteol(n))-1;
 if (n>0)
   {
     sprintf(tampon,"\033[%dD",n);
     A.Direct(tampon);
   }
}

void Display::insert(char key)
{
  int n, i, x, y=0;
  char tampon[50];
  color(LastColor());
  if ((x=Buffer::insert(key))!=-5)
    {
      sprintf(tampon,"\033[%dD\033[K\r\n", x);
      A.Direct(tampon);
      if (ct->debut!=' ')
	{
	  puts(getneol(i, x+1));
	  y=-1;
	}
      else 
	{
	  puts(getneol(i, x));
	}
    }
  if (ct->debut==' ') 
    puts(Buffer::geteol(n));
  else
//    puts(Buffer::getneol(n,y));
    {
      puts(Buffer::getneol(n,y));
//      refresh();
    }
  for (i=0; i<n; i++)
    A.Direct((char)8);
}

void Display::write(char key)
{
  char tampon[10];
  sprintf(tampon,"%c", key);
  A.Direct(tampon);
}

int Display::puts(char *str)
{
  int i=0, j=0;
  while (str[i]!='\0')
    {
	if ((str[i]=='\\') && (str[i-1]!='\\') && (ct->options))
	  {
	    i++;
	    color(str[i]);
	    if (str[i]=='\\')
	      j++;
	  i++;
	  }
	else
	  {
	    A.Direct(str[i++]);
	    j++;
	  }
    }
  delete [] str;
  return j;
}

void Display::left()
{
int col;
char tampon[10]; 
  switch (col = Buffer::left())
    { 
    case -1:
      break;
    case 0:
      A.Direct("\033[1D");
      break;
    default:
      A.Direct("\033[1A");
      sprintf(tampon,"\033[%dC", col-1);
      A.Direct(tampon);
    }
}

void Display::right()
{
int eol;
char tampon[15]; 
  switch (eol=Buffer::right())
    {
    case -1:
      break;
    case 0:
      A.Direct("\033[1C");
      break;
    default:
      sprintf(tampon,"\033[1B\033[%dD",eol);
      A.Direct(tampon);
    }
}

void Display::up()
{
}

void Display::down()
{
}

void Display::bkspace()
{
  int n = 0;
  char col;
  char tampon[10];
  col=Buffer::bkspace();
  switch (col)
    {
    case '\\':
    case '.' :
      refresh();
      break;
    default:
      A.Direct("\033[2D\033[K");
      color(col);
      puts(geteol(n));
      if (n>0)
	{
	  sprintf(tampon,"\033[%dD",n);
	  A.Direct(tampon);
	}
    }
}

void Display::retch()
{
char tampon[5];
  A.Direct("\n\r");
  if (ct->debut!=' ')
    {
      sprintf(tampon,"%c",ct->debut);
      A.Direct(tampon);
    }
}

/*****************************************************************************/
/* Buffer : Gestion du buffer                                                */
/*****************************************************************************/

Buffer::Buffer(Context *ct, int &fin)
{
  this->ct=ct;
  this->fin=fin;
//  printf("AVANT\n");
  buf = new char[ct->lgligne*ct->max+1];
//  printf("val = %d\n",ct->lgligne*ct->max);
 // printf("APRES\n");
  if (ct->deja)
    { 
      strcpy(buf, ct->deja);
      curseur = strlen(ct->deja);
      A.Direct("Yas 1 deja\n");
    } 
  else
    {
      buf[0]=0; 
      curseur=0; 
    }
  col=0;
  eol=0;
  line=0;
  ipile=-1;
  push(ct->color);
}

void Buffer::push(char chr)
{
  ipile++;
  pile[ipile].chr=chr;
  pile[ipile].col=col;
}

void Buffer::pop()
{
  Tpile retour;
  retour.chr=pile[ipile].chr;
  retour.col=pile[ipile].col;
  if (ipile>1) ipile--;
}

Tpile Buffer::get()
{
  Tpile retour;
  retour.chr=pile[ipile].chr;
  retour.col=pile[ipile].col;
  return retour;
}

int Buffer::isspecial(int n)
{
  if ((n>0) && (ipile>0))
    return (col-n==pile[ipile].col);
  else return 0;
}

char Buffer::LastColor()
{
  int i;
  i=ipile;
  while (pile[i].chr=='\\' && i>0)
    i--;
  return pile[i].chr;
}


void Buffer::inscolor(char chr)
{
  ins('\\');
  ins(chr);
  push(chr);
}

void Buffer::inschr(char chr)
{
  if (buf[curseur-1]=='\\' )
    {
      curseur--;
      ins(chr);
      push(chr);
      curseur++;
    }
  else
      ins(chr);
}

void Buffer::ins(char chr, int &pos)
{
  int i = pos;
  char tampon;
  do
    { 
      tampon=buf[i];
      buf[i]=chr;
      chr=tampon;
      i++;
    } 
  while (tampon!='\0');
  buf[i]='\0';
  pos++;
}

void Buffer::color(char c)
{
  if (ct->options && isaffichable(c))
    {
      inscolor(c);
      if (c=='\\') 
	{
	  eol++;
	  col++;
	}
    }
}

char Buffer::bkspace()
// renvoie le dernier code de couleur
{
  int i = curseur;
  char retour = '.';
  int n = 0;
  /* if (0) //col<1 && ct->debut==' ')
     {
     col--;
     eol--;
     n=1;
     while (buf[i+1]!='\0')
     {
     buf[i-n]=buf[i];
     i++;
     }
     curseur-=n;
     }
     else*/
  if ((col>1) || ((col>0) && (ct->debut==' ')))
      {
	i=curseur;
	if (isspecial(1) && get().chr!='\\')
	  {
	    pop();
	    retour=LastColor();
	    n=3;
	    col-=1;
	    eol-=1;
	  }
	else
	  {
	  if (isspecial(1) && get().chr=='\\')
	    {
	      pop();
	      col-=1;
	      eol-=1;
	      n=2;
	      retour='\\';
	    }
	  else
	    {
	      n=1;
	      col-=1;
	      eol-=1;
	    }
	  }
	while (buf[i+1]!='\0')
	  {
	    buf[i-n]=buf[i];
	    i++;
	  }
	curseur-=n;
      }
    else
      {
	// on revient a la ligne precedente
      }
return retour;
}

void Buffer::finedit()
{
  curseur-=2;
  if (ct->debut!=' ')
    curseur--;
  buf[curseur]='\0';
  if (curseur<=0) cancel();
}

void Buffer::cancel()
{
  buf=NULL;
}

void Buffer::insert(char *str)
{
  size_t  len;
  len=strlen(str);
  for (int i=curseur; (size_t)i<len; i++)
    {
      insert(str[i]);
    }
}

int Buffer::insert(char chr)
{
  int retour=-5, i, dif=0;
  if ((eol)>=ct->lgligne) /*Si on est en bout de ligne*/
    {
      for (i=0; (buf[curseur-i-1]!=' ') && i<10; i++);
      if (buf[curseur-i-1]==' ')
	{
	  dif=curseur-i;
	}
      else 
	{
	  i=0;
	  dif=curseur;
	}
      ins('\r',dif);
      ins('\n',dif);
      if (ct->debut!=' ')
	{
	  ins(ct->debut,dif);
	  curseur+=3;
	  retour = i;
	  col = eol = i+1;
	}
      else
	{
	  curseur+=2;
	  retour = i-1;
	  col = eol = i;
	}
      line++;
    }
  if (col==eol)
    {
      write(chr);
    }
  else
    {
      inschr(chr);
      col++;
      eol++;
    }
  return retour;
}

char Buffer::getch()
{
  return *buf;
}

void Buffer::write(char chr)
{
  if (col==eol)
    eol++;
  buf[curseur]=chr;
  buf[curseur+1]='\0';
  curseur++;
  col++;
}

int  Buffer::left()
{
  int retour=-1;
  Tpile colcur;
  colcur=get();
  if ((col>1) || ((col>0) && (ct->debut==' ')))
    {
      if (isspecial(0))
	{
	  pop();
	  curseur-=3;
	}
      else
	curseur--;
      col--;
      retour=0;
    }
  else
    {/*
      if (line<=0)
	return -1;
      else
	{
	  curseur-=3;
	  eol=1;
	  while (buf[curseur-eol]!='>')
	    eol++;
	  col=eol;
	  line--;
	  return col;
	}*/
      // Retour a la ligne d'avant
    }
  return retour;
}

int Buffer::right()
{
  int retour=-1;
  if (col<eol)
    {
      if (buf[curseur]=='\\' && buf[curseur-1]!='\\') 
	{
	  push(buf[curseur+1]);
	  curseur++;
	}
      curseur++;
      col++;
      retour=0;
    }
  else
    {/*
      if (buf[curseur+1]!='\0')
	{
	  line++;
	  curseur++;
	  col=1;
	  eol=1;
	  while (buf[curseur+eol]!='\n' && buf[curseur]!='\0')
	    eol++;
	  retour=1;
	}
      else
	retour=-1;*/
      // Passage a la ligne d'apres si elle existe...
    }
return retour;
}

void Buffer::up()
{
}

void Buffer::down()
{
}

void Buffer::retch()
{
  insert('\n');
  insert('\r');
  cdebut();
}

void Buffer::cdebut()
{
  if (ct->debut!=' ')
    {
      insert(ct->debut);
      col=1;
      eol=1;
    }
  else 
    {
      col=0;
      eol=0;
    }
}

char *Buffer::geteol(int &length)
{
  int i = 0;
  char *retour = new char[ct->lgligne];
  if (isspecial(1) && get().chr=='\\')
    {
      i=-1;
    }
  for (; i<=(eol-col); i++)
    retour[i]=buf[i+curseur-1];
  retour[i]='\0';
  length=i-1;
  return retour;
}

char *Buffer::getneol(int &length, int n)
{
  int i = 0;
  char *retour = new char[ct->lgligne];
  if (isspecial(1) && get().chr=='\\')
    {
      i=-1;
    }
    for (; i<=n; i++)
      if (ct->debut!=' ')
	retour[i]=buf[curseur-n-1+i];
      else
	retour[i]=buf[curseur-n-2+i];	
  retour[i]='\0';
  length=i-1;
  return retour;
}


int Buffer::emptyline()
{
  return ((eol==0) || ((eol==1) && (ct->debut!=' ')));
}

static Commands * a ;

Editeur::Editeur(Context &ct) 
{
  a = new Commands(&ct,&fin);
}

char * Editeur::run()
{
   fin=0;
   while (!fin)
   {
     a->input();
   }
   char * temp = a->getbuf();
   delete a;
   A.Direct("\033[0m");
   return temp;
}


