/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: S. BONNEFOY cerbere@resus.univ-mrs.fr
   Please, send him/them a mail ( possibly with diff and/or correction )

   If you find any BUG, or if you do any improvement */
#ifndef __EDIT_INT__

#define __EDIT_INT__

//#include <stdio.h>
#include <stdlib.h>
#ifndef DEVELOP
#include "Aff.H"
#endif

extern char pipo; // debugage
#ifndef DEVELOP
extern Aff A;
#endif

#include "Context.H"


typedef struct {
  char chr;
  int col;
} Tpile;

class Buffer {
  Context *ct;
  char *buf;//, *debut;
  int fin;
  int curseur;
  int line;
  int eol;
  int col;
  int ipile;
  int colpile;
  Tpile pile[255];
public:
  void insert(char *str);
  int insert(char chr);
  void write(char chr);
  char getch();
  char *getbuf() { return buf; }
  void color(char c);
  char bkspace();
  int left();
  int right();
  void up();
  void down();
  void retch();
  void eob() { buf[curseur-3]='\0'; }
  char *geteol(int &);
  char *getneol(int &, int);
  int getcol() { return col; }
  void finedit();
  Buffer (Context*, int&);
  void push(char chr);
  void pop();
  Tpile get();
  char LastColor();
  int isspecial(int);
  void inschr(char);
  void inscolor(char);
  inline void ins(char chr)
    {
      ins(chr, curseur);
    }
  void ins(char,int &);
  void cdebut();
  void cancel();
  inline int isaffichable(char chr)
    {
      return (chr>32 && chr<127);
    }
  inline int getline() { return line; }
  inline int getneol() { return eol; }
  void ctrlk();
  int emptyline();
  ~Buffer() {
    //delete [] buf;
  };
}; 

 /*class TmpFile : public fstream {
  int line, col; //position du curseur dans le fichier
public:
  TmpFile();
  TmpFile(char *name);
};
*/

class Display : public Buffer {
  Context *ct;
  int fin;
  int line;
public:
  void write(char);
  void insert(char);
  void left();
  void right();
  void up();
  void down();
  void bkspace();
  void color(char c);
  int  puts(char *);
  void retch();
  void refresh();
  Display(Context *ct) : Buffer(ct, fin)
    {
      this->ct=(Context *)ct;
      color(ct->color);
      if (ct->debut!=' ')
	insert(ct->debut);
      line=0;
    }
  ~Display();
  int newline() { line++; return line; }
  int isaffichable(unsigned char chr)  { return chr>30 && chr<128; }
  void ctrlk();
};

class Commands : public Display {
  Context *ct;
  int emptyline;
  enum { mdinsert, mdoverwrite } mode;
  int CtrlD;
  int *fin;
protected:
  char CtrlKey;
public:
  Commands(Context *ct, int *fin) : Display(ct)
  {
    CtrlKey='\t';
    mode = mdinsert;
    CtrlD = 0;
    this->fin=fin;
    this->ct=ct;
    emptyline=1;
  }
  void insert(char);
  void exec(char);
  void ctrlkey(char);
  void color(char c);
  void retch();
  void bkspace();
  void input();
  void finedit();
  void cancel();
  void ctrlk();
}; 

#endif // ndef __EDIT__
