/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

// Analyse.h: interface for the Analyse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANALYSE_H__86CB34D0_1227_11D3_A1E0_0008C773C701__INCLUDED_)
#define AFX_ANALYSE_H__86CB34D0_1227_11D3_A1E0_0008C773C701__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "charToken.h"
#include "nbToken.h"
#include "listenbToken.h"
#include "listeStringToken.h"

#include "ErrAnalyse.h"

extern int currentline;

class Analyse  
{
public:		
	const char * getChar(const char * a);
	char * go(char * buff);	
	int getNumber(const char * a);
	char getType();
	char getName();
	listenbToken * getListeNb(const char * a);
	Analyse();
	virtual ~Analyse();
private:
	char * getNextString();
	char ExpectAlpha();
	int getNextNumber();
	void deleteTokens(Token * first);
	void ignoreSpace();
	Token * chercheToken(Token * first, const char * name);
	void addToken(Token ** first, Token * add);
        void Expect(char a);
	void ExpectReturn();

	char * p;
	char msgname;
	char msgtype;
	listenbToken      * firstlistenb;
	charToken         * firstchar;
	nbToken           * firstnb;
	listeStringToken  * firstlistestring;
};

#endif // !defined(AFX_ANALYSE_H__86CB34D0_1227_11D3_A1E0_0008C773C701__INCLUDED_)
