/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "Post_L.H"
#include "G_B_R_Pipe.H"
#include "S_Users.H"
#include "TAG.H"
#include "S_wholist.H"
#include "Debug.H"

extern G_B_R_Pipe p;
extern S_Users U;
extern S_wholist W;

void X_Send(unsigned short pourki, unsigned short deki, char type,
const char * buffer, unsigned short right)
  // Envoyer un X a un client
{
  if ( ! U.Set(deki,pourki,type)  ) return;
  U.SendX(deki,type,buffer,right);
}



Post_L::Post_L()
  :Post()
{
  MULTIPLE = 1 ;
  TYPE_ROOM = 'L';
}

void Post_L::Lit(S_Load *a)
{
  LIT(a);
  a->Lit(NB_KI);
  a->Lit(type );
  if ( KI )      { delete [] KI; KI=0; }
  if ( KI_Etat ) { delete [] KI_Etat; KI_Etat = 0 ; }
  if ( POS )     { delete [] POS; POS = 0; }
  if ( NB_KI )
    {
      KI      = new unsigned short[NB_KI];
      KI_Etat = new unsigned char [NB_KI];
      POS     = new unsigned short[NB_KI];
      a->Lit(KI,     NB_KI*sizeof(short));
      a->Lit(KI_Etat,NB_KI*sizeof(char ));
      a->Lit(POS,    NB_KI*sizeof(short));
    }
}

void Post_L::Sauve(S_Save *a)
{
  SAUVE(a);
  a->Envoie(NB_KI);
  a->Envoie(type);
  if ( NB_KI )
    {
      a->Envoie(KI,     NB_KI*sizeof(short));
      a->Envoie(KI_Etat,NB_KI*sizeof(char ));
      a->Envoie(POS,    NB_KI*sizeof(short));
    }
}

void Post_L::Recoit(unsigned short nom)
{
  RECOIT(nom);
  p.Lit(type);
  p.Lit(NB_KI);
  KI = new unsigned short[NB_KI+1];
  KI[0]=nom;
  p.Lit(KI+1,NB_KI*sizeof(short));
  NB_KI++;
  Debug(1,"%d --(%c)--> ",nom, type); 
  // Diverses init
  KI_Etat = new unsigned char [NB_KI];
  POS     = new unsigned short[NB_KI];
  int i;
  for (i=0; i< NB_KI; i++) 
    {
      KI_Etat[i]='N';
      POS[i]=0;
    }
  for (i=1; i< NB_KI; i++) 
    {
      unsigned short aki=KI[i];
      Debug(1,"%d ",aki);
      if ( type == 'X' && W.HaveTAG()==aki )
	  X_Send(aki,CocoNum,type,post.data(),0);
      X_Send(aki,nom,type,post.data(),right);
    }
  Debug(1,"\n");
}

void Post_L::Envoie(unsigned short ki)
{
  unsigned short i;
  for ( i=0; i< NB_KI; i++ ) if ( KI[i]==ki) break;
  U.Envoie(POS[i]);

  ENVOIE(ki);
  if ( ki == KI[0] ) i = NB_KI; else i=1;
  U.Envoie(i);
  if ( i )
    {
      U.Envoie(KI     ,i*sizeof(short));
      U.Envoie(KI_Etat,i*sizeof(char ));
    }
  U.Envoie(type);
  U.flush();
}

Post_L::~Post_L()
{
}

const char * Post_L::username()
{
  return W.name(KI[0]);
}


Post * Post_L::CopyPost(void)
{
  Post_L * temp = new Post_L();
  UpdatePost(* temp);
  temp->type = type;
  return temp;
}

