/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

/*
  See S_MSG.H for infos about this class 
*/

#include "S_MSG.H"
#include "Debug.H"  // log messages
#include <string.h> // play with strings
#include "G_Path.H" // Know where are the files to get 

#ifdef SUN_OS
// For SEEK_END
#include <unistd.h>
#endif

extern G_Path G;  // Know where are the files to get 

S_MSG::S_MSG(void)
 :MemCreate(CLEMSG,sizeof(messages))
{
  Load();
}

void S_MSG::Load()
{
  messages * truc=( messages *) MEM;
  FILE * f;
  unsigned int taille,debut=0; // !! warning !! Putting that at int results in a bug since we go > 65535 !!

  // Load the message files in each directory
  for (unsigned int z=0; z<G.Nblg(); z++)
  {
    Debug(2,"Reading message file in %s/ : ",G.Lg(z));
    char temp[100];
    sprintf(temp,"msg/%s/M",G.Lg(z));
    char * tp = G.GetEtcHome(temp);
    f=fopen(tp,"rb");
    delete [] tp;
    if ( ! f) 
      {
	perror("S_MSG::Load()");
	continue;
      }
    // Get size of file
    fseek(f,0,SEEK_END); taille = ftell(f); rewind(f);
    Debug(2,"Size of file = %d\n",taille);
    // Put the file in mem
    fread(truc->msg+debut,taille,1,f);
    fclose(f);
    truc->msg[debut+taille-1]='\n';

    // update start positions
    unsigned int nummsg=1,anciennepos=debut;
    for (unsigned int i=debut;i-debut<taille;i++)
    {
      if (truc->msg[i]=='\n')
      {
        truc->msg[i]=0;
        truc->dpl[z][nummsg]=anciennepos;
        anciennepos=i+1;
        nummsg++;
      }
    }
    Debug(1,"Messages loaded/max num messages = %d/%d\n",nummsg,nb_msg);
    debut+=taille;
  }
  Debug(2,"Size read/Total mem: %d/%d\n",debut,buf_msg);
}

S_MSG::~S_MSG(void)
{
  Debug(0,"S_MSG::~S_MG()\n");
}

