/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __S_R__
#define __S_R__

#include "S_G_room.H" // Generique room
#include "S_room_N.H" // Room with multiple receivers ( mail, X )
#include "S_room_M.H" // Room with no receivers ( normal )
#include "MAX.H"      // e.g. max avaliable rooms


/*
  This is the class which deals with all the rooms of the BBS.
  It receivers the posts, store them in the good rooms, and treat
  all the demands from the clients.
  It asks to the generique rooms to store-retrieve the posts.
*/

class S_R
{
public:
  S_R();
  ~S_R();

  void Receive(unsigned short, int); // Receives a post
  void Deplace(unsigned short);      // Moves a user in a room
  void Envoyer(unsigned short);      // Sends next avaliable post to user
  void SePlacer(unsigned short , unsigned short ); // Verify a user can move
  void Bouge(unsigned short ); 
  void Envoie_Liste(unsigned short ); // Send list of rooms to user
  void flush(void);                   // Flush everything on the HD (saving)
  void Reload(unsigned short ); // recahrge fich cfg room N
  void Reload_Dat(unsigned short ); // Gets a Dat file information for the room
  void DEL(unsigned short nom);     // Deletion of a post
  void Dispatch(unsigned short );   
  void CopierPost(unsigned short);
  void Zap(unsigned short);
private:
  S_room_N * Room_N[MAX_ROOM];
  S_room_M * Room_M;
  S_room_M * Room_L;
  S_G_room * VerifRoom(unsigned short, unsigned short);
};

#endif

