/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "S_user.H"
#include "S_wholist.H"
#include "consts.H"
#include <strings.h>
#include "Debug.H"
#include <string.h>
#include <stdarg.h>
#include "G_Path.H"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h> // pour write & close
#include "mail_user.H"
#include "AddLog.H"

extern S_wholist W;
extern G_Path G;
extern AddLog L;

S_user::S_user(unsigned short numero, int lepid)
  :G_User(W.name(numero)),G_B_S_Pipe(G.GetCommFile(numero)),num(numero),pid(lepid),time_d(0),time_f(0)
{

}

int S_user::AddRequest(void) // returns 1 if user must be kicked
{
  time_t current = time(0);
  tab_time[time_f] = current;
  if ( ++time_f == NB_time ) time_f = 0;
  if ( time_f == time_d ) if ( ++time_d == NB_time ) time_d = 0;
  int diff = time_f - time_d;
  if ( diff < 0 ) diff += NB_time;
  if ( diff == NB_time - 1 )
    return (current-tab_time[time_d]<time_kick);
  return 0;
}

S_user::~S_user(void)
{ 
}

void S_user::SendX(unsigned short deki,unsigned char type, const char * ZeX, unsigned short right)
{
  Envoie((unsigned char)'X');
  Envoie(deki);
  Envoie(type);
  Envoie(right);
  EnvoieG(ZeX);
  flush();
}

void S_user::SendSX(unsigned short deki, unsigned short msg)
{
  Envoie((unsigned char)'X');
  Envoie(deki);
  Envoie((unsigned char)'*');
  Envoie((unsigned short)0); // no rights with this one
  Envoie(msg);
  flush();
}

void S_user::SendMail(char * ki, char * sujet, char * fichier)
{  
  try
    {      
      mail_user hin(W.name(num),ki,sujet,fichier);
    }
  catch ( ... ) 
    { 
      char BUF[100];

      sprintf(BUF,"U(%s)",W.name(num));
      L.AddString(BUF);   
      L.Add("unable to send the mail");
    }
}
		  

