/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Sylvain DURAND , tilde@club-internet.fr
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "Chaine.H"

struct qui   *qui_list;
struct qui   *current_qui;
int      	 qui_nombre;


/*** initialiser la liste des user (*) ***/
void init_qui(void)
{
  qui_list=NULL;
  current_qui=NULL;
  qui_nombre=0;
}



/*** ajouter user (*) ***/
struct qui *add_qui(char *name,int num)
{
  struct qui *nouv;

  nouv=(struct qui *)malloc(sizeof(struct qui));
  	
  nouv->name=(char *)malloc((sizeof(char))*(strlen(name)+1));
  strcpy(nouv->name,name);
  	
  nouv->num=num;
  	
  if (qui_list != NULL)
    qui_list->prev=nouv;
  else
    current_qui=nouv;
  
  nouv->next=qui_list;
  nouv->prev=NULL;
  qui_list=nouv;
  
  qui_nombre++;
  
  return(nouv);
}

/*** effacer qui ***/
void del_qui(struct qui *ki)
{
  
  if (ki != NULL)
    {
      if (qui_list == ki)
	qui_list=ki->next;
      if (ki->next != NULL)
	ki->next->prev=ki->prev;
      if (ki->prev != NULL)
	ki->prev->next=ki->next;
      qui_nombre--;
      free(ki->name);
      free(ki);
    }
}

/*** trouver qui ***/
struct qui *trouve_qui(int num)
{
  struct qui *ki;
  
  for (ki=qui_list;ki != NULL;ki=ki->next)
    if (ki->num == num)
      return(ki);
  return (NULL);
}

/*** retourne le nom du qui passe en argument ***/
char *retourne_qui_name(struct qui *ki)
{
  return(ki->name);
}

/*** retourne le numero de num du qui passe en argument ***/
int retourne_qui_num(struct qui *ki)
{
  return(ki->num);
}

/*** retourne le qui next ***/
struct qui *retourne_qui_next(struct qui *ki)
{
	return(ki->next);
}

/*** retourne le qui suivant ***/
struct qui *retourne_qui_suiv()
{
  if (current_qui->next!=NULL)
    current_qui=current_qui->next;
  else
    current_qui=qui_list;

  return(current_qui);
}

/*** retourne le qui courant ***/
struct qui * retourne_qui_courant(void)
{
  return(current_qui);
}

/*** retourne le qui precedent ***/
struct qui *retourne_qui_prev(struct qui *ki)
{
  return(ki->prev);
}

/*** retourne le premier qui ***/
struct qui *retourne_qui_first(void)
{
  return(qui_list);
}

/*** retourne le nombre de quis ***/
int retourne_qui_nombre(void)
{
  return(qui_nombre);
}

/*** modifie le qui courant ***/
struct qui *modifie_qui_courant(struct qui *ki)
{
  current_qui=ki;
  return(current_qui);
}



/*** afficher liste qui (*) ***/
void affiche_qui_list(void)
{
  struct qui *ki;
  
  for (ki=qui_list;ki != NULL;ki=ki->next)
    printf("%-15s <%d>\n",ki->name,ki->num);
}


/*** afficher qui (*) ***/
void affiche_qui(struct qui *ki)
{
  printf("qui : %s <%d>\n",ki->name,ki->num);
}


/*
void main ()
{

	init_qui();
	
	add_qui("gnagna",6667);
	add_qui("gnagna2",6667);
	add_qui("gnagna3",6667);
	add_qui("gnagna4",6667);
	add_qui("gnagna5",6667);
	add_qui("gnagna6",6667);
	add_qui("gnagna7",6667);
	add_qui("gnagna8",6667);
	add_qui("gnagna9",6667);
	add_qui("gnagna10",6667);
	add_qui("gnagna11",6667);
	add_qui("gnagna12",6667);
	add_qui("gnagna13",6667);
	add_qui("gnagna14",6667);
	add_qui("gnagna15",6667);
	
	affiche_qui_list();

	printf("current ");
	affiche_qui(retourne_qui_courant());

	printf("nombre de quis : %d\n",retourne_qui_nombre());
	affiche_qui(retourne_qui_next(retourne_qui_first()));
	
	
	del_qui(retourne_qui_next(retourne_qui_first()));
	del_qui(trouve_qui("gnagna10",6667));
	del_qui(trouve_qui("gnagna15",6667));
	del_qui(trouve_qui("gnagna",6667));
	affiche_qui_list();
	printf("nombre de quis : %d\n",retourne_qui_nombre());
	
	
}
*/
