/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
 
/*
   This program have been made by: Sylvain DURAND , tilde@club-internet.fr
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "Client.H"
#include "Chaine.H"

#include "../parser/Analyse.h"


#define BUF_SIZE        1024

#define PASSWORD_CHAR   'o'


int GetName(char * str, int len) {
    char    c = 0;
    int     i = 0;
    int     must_be_upper = 1;
    int     space_allowed = 0;
    
    
    while(i <= len) {
        c = getc(stdin);
        
        // Context tests
        if(i == 0 || (i > 0 && str[i-1] == SPC)) {
            must_be_upper = 1;
            space_allowed = 0;
        }
        
        if(i > 0 && isalpha(str[i-1])) {
            must_be_upper = 0;
            space_allowed = 1;
        }
        
        // Backspace
        if(c == BS || c == DEL) {
            if(i > 0) {
                str[i] = 0;
                i--;
                str[i] = 0;
                putc(BS,  stdout);
                putc(SPC, stdout);
                putc(BS,  stdout);
            }
            continue;
        }
        
        // Enter
        if(c == CR || c == LF) {
            // Avoiding leading spaces
            if((space_allowed == 0) && (i>0)) {
                str[i-1] = 0;
            } else {
                str[i] = 0;
            }
            putc(CR, stdout);
            putc(LF, stdout);
            break;
        }
        
        // Cancel (ctrl-c or ctrl-d)
        if(c == ETX || c == EOT) {
            continue;
        }
        
        // End of buffer
        if(i == len) {
            putc('\a', stdout);
            continue;  // -> looping
        }
        
        // Space
        if(c == SPC) {
            if(space_allowed) {
                str[i] = SPC;
                i++;
                putc(SPC, stdout);
                must_be_upper = 1;
                space_allowed = 0;
                continue;
            }
            
            tcflush(0, TCIFLUSH);
            continue;
        }
        
        // Non-alpabetic character
        if(!isalpha(c) && c != SPC) {
            putc('\a', stdout);
            tcflush(0, TCIFLUSH);
            continue;
        }
        
        // Alphabetic character
        if(islower(c) && must_be_upper) {
            str[i] = toupper(c);
            
        } else {
            str[i] = c;
        }
        
        putc(str[i], stdout); 
        must_be_upper = 0;
        space_allowed = 1;
        i++;
    }
    
    str[i] = 0;
    
    return i;
}

char * GetPassword(char * prompt) {
    char *  pass = new char [BUF_SIZE + 1];
    char    c = 0;
    int     i = 0;
    
    printf(prompt);
    
    while(i <= BUF_SIZE) {
        c = getc(stdin);
        
        // Backspace
        if(c == BS || c == DEL) {
            if(i > 0) {
                pass[i] = 0;
                i--;
                pass[i] = 0;
                putc(BS,  stdout);
                putc(SPC, stdout);
                putc(BS,  stdout);
            }
            continue;
        }
        
        // Enter
        if(c == CR || c == LF) {
            pass[i] = 0;
            putc(CR, stdout);
            putc(LF, stdout);
            break;
        }
        
        // Cancel (ctrl-c or ctrl-d)
        if(c == ETX || c == EOT) {
            continue;
        }
        
        // End of buffer
        if(i == BUF_SIZE) {
            putc('\a', stdout);
            continue;  // -> looping
        }
        
        pass[i] = c;
        putc(PASSWORD_CHAR, stdout);
        i++;
    }
    
    pass[i] = 0;
    
    return pass;
}

int
read_message (int soc, char buffer[2048])
{
  int count = 0;
  char carlu;
  int read_result;

  do
    {
      if ((read_result = read (soc, &carlu, sizeof (char))) == 1)
        {
          buffer[count] = carlu;
          count++;
        }
    }
  while ((carlu != '\0') && (read_result == 1));
  count--;

  if (read_result == 1)
    return count;
  else
    return read_result;
}

void TraiteMsg(Analyse &a)
{

}

int 
main (void)
{

  int main_socket;
  struct sockaddr_in serv_name;
  char buffer[1024];
  int count;
  //int count_name;
  //int count_pass;
  int logout;
  char carlu;
  fd_set fdset;
  int selretval;

  int log = 0;
  char log_name[20];
  char *log_pass;
  int last_num=-1;
  char tok='V';

  // termios

  int oldMin;
  tcflag_t oldCtrl;

  // termios

  init_qui();

  printf ("Pipo Client v%s on %s at %s\n", VERSION, __DATE__, __TIME__);

  if ((main_socket = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror ("Fatal error: Unable to open server's main socket");
      exit (1);
    }

  serv_name.sin_family = AF_INET;
  serv_name.sin_port = htons (SERV_PORT);
  if ((inet_aton (SERV_ADDR, &serv_name.sin_addr)) == 0)
    {
      close (main_socket);
      perror ("Fatal error: Server name incorrect");
      exit (3);
    }
#ifdef DEBUG
  printf ("DEBUG : ntohs (serv_name.sin_port) : ");
  printf ("%d\n", ntohs (serv_name.sin_port));
  printf ("DEBUG : ntohl (serv_name.sin_addr.s_addr) : ");
  printf ("%x\n\n", ntohl (serv_name.sin_addr.s_addr));
#endif
  if ((connect (main_socket, (struct sockaddr *) &serv_name, sizeof (serv_name))) < 0)
    {
      close (main_socket);
      perror ("Fatal error: Unable to connect to server");
      exit (4);
    }

  logout = 0;

  // termios

  termios termtype;
  tcgetattr (STDIN_FILENO, &termtype);
  oldCtrl = termtype.c_lflag;
  oldMin = termtype.c_cc[VMIN];
  termtype.c_lflag &= !(ECHO | ICANON);
  termtype.c_cc[VMIN] = 1;
  tcsetattr (STDIN_FILENO, TCSANOW, &termtype);

  // fin termios

  // Envoie du host

  buffer[0] = '\0';

  sprintf (buffer, "S (V)\n\t{\n\tversion = \"%s\"\n\t}\n",P_VERSION);
  write (main_socket, buffer, strlen (buffer) + 1);

  // *** LOGIN

  do
    {
      do
	{
	  printf("login: ");
	  count=GetName(log_name,19);
	}
      while (count==0);

      log_pass=GetPassword("Password: ");
  
      buffer[0] = '\0'; //Envoie du login et du password
      sprintf(buffer,"S (L)\n\t{\n\tlogin = \"%s\"\n\tpassword = \"%s\"\n\t}\n",log_name,log_pass);
      
      write (main_socket, buffer, strlen(buffer)+1);
      
      if ((count = read_message (main_socket, buffer)) < 0)
	{
	  close (main_socket);
	  perror ("Fatal error: Unable to read message from server");
	  exit (5);
	}
      char *buff;
      
      buff = new char[5000+1];
      
      Analyse a;
      sprintf(buff,"%s",buffer);
      buff=a.go(buff);
      
      char *answer=a.getChar("answer");
      
      if (strcmp (answer, "ok") == 0)
	{
	log = 1;
	}
      else if (strcmp (answer, "wrong password") == 0)
	{
	  printf ("Wrong login. Please retry.\n\n");
	}
      
      else if (strcmp (answer, "bad user") == 0)
	{
	  printf ("User doesn't exist. Please retry.\n\n");
	}
      else if (strcmp (answer, "max user") == 0)
	{
	  printf ("Max user.\n\n");
	  tcgetattr (STDIN_FILENO, &termtype);
	  termtype.c_lflag = oldCtrl;
	  termtype.c_cc[VMIN] = oldMin;
	  tcsetattr (STDIN_FILENO, TCSANOW, &termtype);
	  close (main_socket);
	  exit (0);
	}
      
      else if (strcmp (answer, "stop execution") == 0)
	{
	printf ("Server deconnection. Bye Bye.\n\n");
	tcgetattr (STDIN_FILENO, &termtype);
	termtype.c_lflag = oldCtrl;
	termtype.c_cc[VMIN] = oldMin;
	tcsetattr (STDIN_FILENO, TCSANOW, &termtype);
	close (main_socket);
	exit (0);
	}
      else if (strcmp (answer, "protocol error") == 0)
	{
	  printf ("Server couldn't understand. Bye Bye.\n\n");
	  close (main_socket);
	  exit (0);
	}
      else
	{
	  printf ("Ouch! Couldn't understand server answer.\n\n");
	}
      delete [] buff;
    }
  while (!log);
  
  // *** END OF LOGIN

  printf ("Connected to BBS.Welcome %s.\n\n", log_name);

  /*
   * -A FAIRE-
   * Demande des infos sur les utilisateurs deja connectes...
   * -A FAIRE-
   */


  while (!logout)
    {
      if(tok=='V')
	{
	  printf("\n-=Version=--- Les Touches activeeS: [x|w|W|l] ---=%s=-\n\n", VERSION);

	  printf ("On Ze Deck>");
	  fflush (stdout);
	}

      memset (buffer, 0, sizeof (buffer));
      count = 0;

      FD_ZERO (&fdset);

      FD_SET (0, &fdset);
      FD_SET (main_socket, &fdset);

#ifdef HP_UX
      selretval = select ((main_socket + 1), (int *) &fdset, NULL, NULL, 0);
#else
      selretval = select ((main_socket + 1), &fdset, NULL, NULL, 0);
#endif

      if (selretval < 0)
	{
	  close (main_socket);
	  perror ("Fatal error: Select error");
	  exit (5);
	}

      if FD_ISSET
	(main_socket, &fdset)
	{
#ifdef DEBUG
	  printf ("Incoming message!\n");
#endif
	  if ((count = read_message (main_socket, buffer)) < 0)
	    {
	      close (main_socket);
	      perror ("Fatal error: Unable to read message from server");
	      exit (5);
	    }
#ifdef DEBUG
	  printf ("Network client received the message :\n\"%s\"\nfrom server\n\n", buffer);
#endif
        char *buff;

        buff = new char[5000+1];

	buff[0]='\0';

	Analyse a;

        sprintf(buff,"%s",buffer);
        buff=a.go(buff);

	  if (a.getType() == 'A')
	    {
	      char *user=a.getChar("user");
#ifdef DEBUG
	      printf("getChar=%s\n",a.getChar("user"));
#endif
	      switch (a.getName())
	      {
	      case 'C':
		{

		  char packet[1024];

		  sprintf (packet, "G (U)\n\t{\n\tnum = \"%s\"\n\t}\n",
			   user);
		  write (main_socket, packet, strlen (packet) + 1);
  
		  last_num=atoi(user);
		  tok='L';
		}
		break;
	      case 'D':
		{

		  if (trouve_qui(atoi(user))!=NULL)
		    {
		      printf ("%s Logout\n", 
			      retourne_qui_name(trouve_qui(atoi(user))));
		      del_qui(trouve_qui(atoi(user)));
		    }
		  else
		    printf("Someone (%s) logout...\n",user);
		}
		break;
	      case 'N':
		{


		  add_qui(log_name,atoi(user));
                delete [] user;
		}
		break;
	      case 'U':
		{

#ifdef DEBUG
		  printf ("-Recieved Ack U (%d)->%s\n", last_num,user);
#endif
		  add_qui(user,last_num);
		  switch(tok)
		    {
		    case 'L':
		      printf ("%s Login\n", user);
		      break;
		    case 'X':
		      printf ("%s recieved message\n", user);
		      break;
		    case 'W':
		      break;
		    }
		  tok='V';
		  last_num=-1;
		}
		break;
	      case 'X':
		{

		  if (trouve_qui(atoi(user))==NULL)
		    {
		      char packet[1024];

		      sprintf (packet, "G (U)\n\t{\n\tnum = \"%s\"\n\t}\n",
			       user);
		      write (main_socket, packet, strlen (packet) + 1);
  
		      last_num=atoi(user);
		      tok='X';

		    }
		  else printf ("%s recieved message\n", 
			       retourne_qui_name(trouve_qui(atoi(user))));
		}
		break;
	      }
	      user=NULL;
	    }
	  if (a.getType() == 'S')
	    switch (a.getName())
	      {
	      case 'X':
		{
		  char * spec= a.getChar("spec");
		  char * from= a.getChar("from");
		  char * msg= a.getChar("msg");
		  
		  if (atoi(from)!=0)
		    {
		      printf ("\n-- %s Message from %s --\n%s\n",spec,from,msg);
		      
		      char *pack=new char[1024];
		      
		      sprintf (pack, "A (X)\n\t{\n\tuser = \"%s\"\n\t}\n"
			       , from);
		      
		      write (main_socket, pack, strlen (pack) + 1);
		      
		      sprintf(buffer,"%s",pack);
		      
		      delete [] pack;
		    }
		  else			// c'est un message du systeme 
		    printf ("%s\n", msg);
		}
		break;
	      case 'W':
		{
		  int num=a.getNumber("num");
		  char *nick=a.getChar("nick");
		  
		  if (trouve_qui(num)==NULL)
		    add_qui(nick,num);		  
		}
		break;
	      }
	}
      else if FD_ISSET
	(0, &fdset)
	{
	  carlu = ' ';
	  count = 0;

// Mettre ca en sous programme
	  char username[20];
	  username[0]= '\0';

	  carlu = getchar ();
	  printf ("%c\n", carlu);
	  switch (carlu)
	    {
	    case 'x':
	      {
		count = 0;
		username[0]= '\0';
		printf ("Type the number of the user: ");
		while (carlu != '\n')
		  {
		    carlu = ' ';
		    carlu = getchar ();
		    if (isdigit(carlu) || (carlu == '\n'))
		      {
			printf ("%c", carlu);
			if (carlu != '\n')
			  {
			    username[count] = carlu;
			    count++;
			  }
		      }
		  }

		printf ("-Sending X-Message to %d-\n", atoi(username));

		carlu = ' ';
		count = 0;

		buffer[count] = '>';	//Rajoute le prompt

		count++;
		printf (">");
		while (carlu != '\n')
		  {
		    carlu = getchar ();
		    printf ("%c", carlu);
		    if (carlu != '\n')
		      {
			buffer[count] = carlu;
			count++;
		      }
		  }


		buffer[count] = '\0';
		count++;

		char *packet=new char [1024];

		sprintf (packet, "S (X)\n\t{\n\tspec = \"X\"\n\tto = \"%d\"\n\tmsg = \"%s\"\n\t}\n", atoi(username)
			 , buffer);

		write (main_socket, packet, strlen (packet) + 1);

		delete [] packet;
	      }
	      break;
	    case 'a':
	      {
		char *packet=new char [1024];

		sprintf (packet, "G (U)\n\t{\n\tnum = \"30\"\n\t}\n");
		last_num=30;

		write (main_socket, packet, strlen (packet) + 1);

		delete [] packet;
	      }
	      break;
	    case 'w':
	      {
		printf("\n=-Wholist %d users connected-=\n",retourne_qui_nombre());
		affiche_qui_list();
		printf("]----=------=------=-----------=-\n");
	      }
	      break;
	    case 'W':
	      {
		char *packet=new char [1024];

		sprintf (packet, "G (W)\n\t{\n\tspec = \"short\"\n\t}\n");
#ifdef DEBUG
		printf ("-send->\n%s\n", packet);
#endif
		write (main_socket, packet, strlen (packet) + 1);

		delete [] packet;
	      }
	      break;
	    case 'l':
	      {
		char *packet=new char [1024];

		sprintf (packet, "S (D)\n\t{\n\tmsg = \"Bye\"\n\t}\n");
#ifdef DEBUG
		printf ("-send->\n%s\n", packet);
#endif
		write (main_socket, packet, strlen (packet) + 1);

		tcgetattr (STDIN_FILENO, &termtype);
		termtype.c_lflag = oldCtrl;
		termtype.c_cc[VMIN] = oldMin;
		tcsetattr (STDIN_FILENO, TCSANOW, &termtype);
		printf ("Closing connection\n");
		delete [] packet;
		close (main_socket);
		exit (0);
	      }
	      break;
	    default:
	      printf ("Commande %c inconnue\n", carlu);
	      break;
	    }
#ifdef DEBUG
	  printf ("Network client send the message :\n\"%s\"\nto server\n\n", buffer);
#endif
	}

      else
	{
	  close (main_socket);
	  perror ("Fatal error: Unable to locate the source of select return");
	  exit (6);
	}
    }


  return 0;
}


void 
terminate (void)
{
  printf ("Ze termine\n");
  exit (0);
}
