/*
   Copyright (C) 1992 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Sylvain DURAND , tilde@club-internet.fr
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __SOCKET__
#define __SOCKET__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "consts.H"
#include "C_User_C.H"
#include "Con_Wholist.H"

#define BUFF_LEN                 1024	 // Taille du buffer
#define VER_LEN                  7
#define NUMLEN                   5


class Socket
{
public:
  Socket (int);
  ~Socket ();
  void Set (class C_User_C *);					// Set Pi
  void Gere (void);					// Gere a msg received on socket
  void SendX (unsigned char, const char *, unsigned short);	// Send an X to client
  int GetLogin (char **, char **);				// Get client login
  int GetX (char *,char **, char **);                                   //Get client X
  int GetVer(char **);
  void SendAck (char, char *);                          // Send Acknowledgment

private:
  char buffer [BUFF_LEN];        // Buffer de messages serveur-client
  int count;                      // Longueur du message dans le buffer
  int fd; 			// socket descriptor (to client)
  C_User_C *Pi;			// Pipe descriptor (to server)
};



#endif

