/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
 
/*
   This program have been made by: Sylvain DURAND , tilde@club-internet.fr
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "Socket.H"

#include "../parser/Analyse.h"

int
read_message (int soc, char buffer[2048])
{
  int count = 0;
  char carlu;
  int read_result;

  do
    {
      if ((read_result = read (soc, &carlu, sizeof (char))) == 1)
        {
          buffer[count] = carlu;
          count++;
        }
    }
  while ((carlu != '\0') && (read_result == 1));
  count--;

  if (read_result == 1)
    return count;
  else
    return read_result;
}

Socket::Socket (int client_socket)
{
  fd = client_socket;

  /************************************************/
  /* On nettoie le buffer avant toute utilisation */
  /************************************************/

  memset (buffer, 0, sizeof (buffer));
  count = 0;
}

void Socket::
Set (C_User_C * serv_pipe)
{
  Pi = serv_pipe;
}

void Socket::
Gere (void)
{
  Con_Wholist W;
  
  //if ((count = read_message (fd, buffer)) < 0)
  if ((count = read (fd, buffer, sizeof (buffer))) < 0)
    {
#ifdef DEBUG
      perror ("Fatal error: Unable to read from client");
#endif
      Pi->Baille ();		// on previent serveur ke yapasbon, aurevoir

      exit (-6);
    }

  char *buff = new char[5000+1];

  buff[0]='\0';
	
  Analyse a;
  try
    {

      sprintf(buff,"%s",buffer);
      buff=a.go(buff);
      //#ifdef DEBUG 

      printf(".oO %c (%c) Oo.\n",a.getType(),a.getName());
      //#endif      
      switch (a.getType())
	{
	case 'S':			//Le range est  X ou D, (Socket)
	  
	  {
	    switch (a.getName())
	      {
	      case 'X':		//X message
		
		{
		  char *spec=a.getChar("spec");
		  char *to=a.getChar("to");
		  char *content=a.getChar("msg");
		  
		  LISTE AKIJESEND (40);	// on dit k'on peut envoyer ce MSG a max
		                       // 40 trouducs
		  
		  if (W.connected(atoi(to)) == 0)	// l'utilisateur n'est pas connecte
		    
		    {
		      SendX ('X',"user non connecte !", 0);
		      return;
		    }
		  
		  AKIJESEND.Ajoute (atoi (to));
		  // on envoye le message, de type X-message
		  Pi->SendX (AKIJESEND, *spec, content, 0);
		}
		break;
	      case 'D':		//Demande de deconnection du client
		
		{
#ifdef DEBUG
		  printf ("Message de deconnection du client\n");
#endif
		  Pi->Baille ();	// On previent Vdb-server ke plus de client
		  
		  close(fd);
		  
		  return;
		}
		break;
	      }
	  }
	  break;
	case 'A':			//Le range est obligatoirement X (Ack) pour le moment
	  
	  {
	    char *user=a.getChar("user");
#ifdef DEBUG
	    printf ("Envoie en Ack X a %s\n", user);
#endif
	    Pi->Ack (atoi (user), 'a');
	    
	  }
	  break;
	case 'G':
	  {
	    switch (a.getName())
	      {
	      case 'I':		//Demande des infos sur lui-meme
		
		break;
	      case 'P':		//Demande le profile d'un user
		
		break;
	      case 'U':		//Demande le nom d'un utilisateur d'apres son numero
		{
		  char *num=a.getChar("user");
#ifdef DEBUG
		  printf("User %s (%s)\n",W.name(atoi(num)),num);
#endif  
		  //Envoie d'un A(U) avec le nom...
		  SendAck('U', W.name(atoi(num)));
		}
		break;
	      case 'W': //Demande de la wholist	
		{
		  //Envoie d'un G(W) avec la wholist...
		  
		  time_t      now     = time(NULL);
		  int i;
		  USRINFO *   user    = NULL;
		  int         flags   = 0;
		  int         minutes = 0;
		  int         hours   = 0;
		  char        flag;
		  
		  char *spec = a.getChar("spec");
#ifdef DEBUG		  
		  printf("Demande de 'wholist'\n");
#endif
		  /*
		    for(i=0; i<W.NB(); i++)
		    printf("->%s (%d)\n",W.name(W.mem->ki[i]),W.mem->ki[i]);
		  */
		  for(i=0; i<W.NB(); i++) 
		    {
		      user = W.User(W.mem->ki[i]);
		      
		      flag=' ';
		      
		      if(!user)
			continue;
		      
		      // User Name --
		      //printf("%d\n",W.mem->ki[i]);
		      
		      // User Flags --
		      flags = user->u_wholist;
		      if(flags & W_Hidden) flag='!';   // Hidden
		      if(flags & W_Tag   ) flag='C';   // Coco
		      if(flags & W_Help  ) flag='%';  // SysGuide
		      if(flags & W_Disabl) flag='*';   // X-Disabled
		      if(flags & W_poste ) flag='+';   // Posting
		      if(flags & W_X     ) flag='x';   // Xing
		      if(flags & W_buisy ) flag='?';   // Busy
		      if(flags & W_Chat  ) flag='&';   // Chatting
		      if(!(user->u_options & U_Verified)) flag='V';   // Unvalidated
		      
		      // Connected Time --;
		      minutes = (now - user->login) / 60;
		      hours = minutes / 60;
		      minutes %= 60;
		      //printf("%d:%02d\n", hours, minutes);
		      
		      /* Il manque un teste !!!		  
			 // Idle Time --
			 minutes = (now - user->last) / 60;
			 hours = minutes / 60;
			 minutes %= 60;
			 //printf("%d:%02d\n", hours, minutes);
		      */
		      // Hostname --
		      //printf("%s\n", user->From);
		      
		      // Doing --
#ifdef DEBUG
		      if(flags & W_Disabl) 
			{
			  // X-Disabled, so we replace the normal war cry 
			  // with the disable reason. 
			  printf("%-10s(%d)  %c %d:%02d %-20s %-20s\n", W.name(W.mem->ki[i]) 
				 , W.mem->ki[i], flag
				 , hours, minutes
				 , user->From, user->Raison);
			} 
		      else 
			{
			  printf("%-10s(%d)  %c %d:%02d %-20s %-20s\n", W.name(W.mem->ki[i])
				 ,W.mem->ki[i], flag
				 , hours, minutes
				 , user->From, user->Doing);
			}
#endif
		      buffer[0]='\0';
		      
		      sprintf (buffer, "S (W)\n\t{\n\t#num = %d\n\t$nick = \"%s\"\n\t}\n"
			       , W.mem->ki[i]
			       , W.name(W.mem->ki[i]));
		      write (fd, buffer, strlen (buffer) + 1);
		    }
		}
		break;
	      }
	  }
	  break;
	}
    } 
  catch ( ErrAnalyse * e )
    {
#ifdef DEBUG
      printf("Erreur d'analyse: %s\n",e->msg);
#endif
    }  
#ifdef DEBUG  
  printf("Fin du switch\n");
#endif
}

void Socket::
SendX (unsigned char what, const char *Message, unsigned short from)
{
  /********************************/
  /* Envoyer le message au client */
  /********************************/

  char *packet=new char [2048];

  buffer[0] = '\0';
  if (!Message)
    return;			// On evite les envoies de msgs vides
#ifdef DEBUG
  printf ("On va envoyer un %c message \"%s\" de la part de %d\n", what, Message, from);
#endif  
  //Il faut gerer les differents type de message
  sprintf (packet, "S (X)\n\t{\n\tspec = \"%c\"\n\tfrom = \"%d\"\n\tmsg = \"%s\"\n\t}\n", what, 
	   from, Message);
  
  write (fd, packet, strlen(packet) + 1);

  delete [] packet;
  
}

int Socket::
GetLogin (char **login_name, char **login_pass)
{
  int result = 0;

  if ((count = read (fd, buffer, sizeof (buffer))) < 0)
    {
      result = -4;
    }
  else
    {
      buffer[count] = '\0';
      char *buff;
      
      
      buff = new char[5000+1];
      
      Analyse a;
      sprintf(buff,"%s",buffer);
      buff=a.go(buff);
      
      result=0;

      *login_name=a.getChar("login");
      *login_pass=a.getChar("password");

      delete [] buff;
    }

  return result;
}

int Socket::
GetVer (char **ver)
{
  int result = 0;

  if ((count = read (fd, buffer, sizeof (buffer))) < 0)
    {
      result = -4;
    }
  else
    {
      buffer[count] = '\0';
      
      char *buff;
	      
      buff = new char[5000+1];
      
      Analyse a;
      sprintf(buff,"%s",buffer);
      buff=a.go(buff);
      
      *ver=a.getChar("version");
      
      result=0;

      ver[VER_LEN] = '\0';

      delete [] buff;
    }

  return result;
}

void Socket::
SendAck (char range, char *answer)
{
  char *content;
  char *packet=new char [2048];

  content = new char[10];

  switch (range)
    {
    case 'L':
      strcpy(content,"answer");
      break;
    case 'C': //Un user se loge
    case 'D': //Un user se deloge
    case 'N': //Le serveur envoie le numero de l'utilisateur qui se connecte
    case 'U': //Le client veut le login d'un user (il possede que son numero)
    case 'X': //Accuse de reception d'un X
      strcpy(content,"user");
      break;
    }
  
  sprintf (packet, "A (%c)\n\t{\n\t%s = \"%s\"\n\t}\n", range, content, answer); 
#ifdef DEBUG
  printf("-send->\n%s\n",packet);
#endif
  write (fd, packet, strlen (packet) + 1);

  delete [] packet;
  delete [] content;
}
 
Socket::~Socket ()
{
  close (fd);
}
